/**
 * An identifier for tiles (can also be used for tile layers)
 */
export interface TileKeyObject {
  /**A tile provider id ('osm', 'otm', ...) */
  provider: string;
  /**The zoom level (integer) */
  zoomLevel: number;
  /**The X coordinate (integer)*/
  x: number;
  /**The Y coordinate (integer) */
  y: number;
}

/**
 * A point
 */
export interface Point {
  /**The X coordinate (integer)*/
  x: number;
  /**The Y coordinate (integer) */
  y: number;
}

/**
 * A rectangle
 */
export interface Rectangle {
  topLeft: Point;
  bottomRight: Point;
}

/**
 * A function which creates tiles
 * @param keyObject - the {@link TileKeyObject} identifying the tile.
 */
export type TileFactory = (keyObject: TileKeyObject) => any;
